## imhex-patterns 1.29.0

=== tests/patterns/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(patterns_tests)

set(TOP_LEVEL "${CMAKE_CURRENT_SOURCE_DIR}/../..")

file(GLOB PATTERNS
    "${TOP_LEVEL}/patterns/*.hexpat"
)

set(PATTERN_INCLUDES "${TOP_LEVEL}/includes")

add_executable(patterns_tests
        source/main.cpp
)

target_include_directories(patterns_tests PRIVATE include)
target_link_libraries(patterns_tests PRIVATE libpl fmt::fmt-header-only)

set_target_properties(patterns_tests PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

foreach (pattern IN LISTS PATTERNS)
    get_filename_component(PATTERN_NAME ${pattern} NAME)

    file(GLOB TEST_FILES "${CMAKE_CURRENT_SOURCE_DIR}/test_data/${PATTERN_NAME}.*")

    if (TEST_FILES)
        list(GET TEST_FILES 0 TEST_FILE)
    else ()
        set(TEST_FILE "")
    endif ()

    set(TEST_NAME "Patterns/${PATTERN_NAME}")

    add_test(NAME ${TEST_NAME} COMMAND patterns_tests "${PATTERN_NAME}" "${pattern}" "${PATTERN_INCLUDES}" "${TEST_FILE}" WORKING_DIRECTORY ${CMAKE_BINARY_DIR})
    set_tests_properties(${TEST_NAME} PROPERTIES SKIP_RETURN_CODE 77)
endforeach ()

=== debian/changelog ===
imhex-patterns (1.29.0-0parrot1) lory; urgency=medium

  * Rebuild for Parrot 6.0.

 -- Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>  Thu, 07 Sep 2023 01:45:01 +0200

imhex-patterns (1.29.0-0kali1) kali-dev; urgency=medium

  * Initial release.

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 09 Jun 2023 16:33:27 +0200

=== debian/control ===
Source: imhex-patterns
Section: misc
Priority: optional
Maintainer: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
Uploaders: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
Standards-Version: 4.6.2
Homepage: https://github.com/WerWolv/ImHex-Patterns

Package: imhex-patterns
Architecture: all
Depends:
 ${misc:Depends},
Description: ImHex Database
 This package contains a database for files to use with the ImHex Hex Editor.
 It currently contains:
    * Patterns - Binary Format definitions for the Pattern Language
    * Pattern Libraries - Libraries that make using the Pattern Language easier
    * Magic Files - Custom magic file definitions for the use with libmagic
    * Encodings - Custom encodings in the .tbl format
    * Data Processor Nodes - Custom nodes made for ImHex's Data Processor
    * Themes - Custom themes for ImHex
    * Constants - Constants definition files
    * Scripts - Various scripts to generate code or automate some tasks
    * Yara - Custom Yara rules

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
    https://github.com/WerWolv/ImHex/tags \
    (?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@

## imhex-patterns 1.35.4

=== tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(tests)

set(CMAKE_CXX_STANDARD 20)

include(FetchContent)

FetchContent_Declare(
    pattern_language
    GIT_REPOSITORY      https://github.com/WerWolv/PatternLanguage
    GIT_TAG             master
)

FetchContent_MakeAvailable(pattern_language)

enable_testing()

add_subdirectory(patterns)
add_subdirectory(includes)
add_subdirectory(magic)

add_custom_target(test_all DEPENDS patterns_tests includes_test magic_test)

=== tests/includes/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(includes_test)

set(TOP_LEVEL "${CMAKE_CURRENT_SOURCE_DIR}/../..")

file(GLOB INCLUDES
    "${TOP_LEVEL}/includes/*/*.pat"
)

set(PATTERN_INCLUDES "${TOP_LEVEL}/includes")

add_executable(includes_test
        source/main.cpp
)

target_include_directories(includes_test PRIVATE include)
target_link_libraries(includes_test PRIVATE libpl fmt::fmt-header-only)

set_target_properties(includes_test PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

foreach (include IN LISTS INCLUDES)
    file(RELATIVE_PATH INCLUDE_NAME ${PATTERN_INCLUDES} ${include})

    set(TEST_NAME "Includes/${INCLUDE_NAME}")

    add_test(NAME ${TEST_NAME} COMMAND includes_test "${INCLUDE_NAME}" "${include}" "${PATTERN_INCLUDES}" WORKING_DIRECTORY ${CMAKE_BINARY_DIR})
    set_tests_properties(${TEST_NAME} PROPERTIES SKIP_RETURN_CODE 77)
endforeach ()

=== tests/magic/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(magic_test)

set(TOP_LEVEL "${CMAKE_CURRENT_SOURCE_DIR}/../..")

set(MAGIC_FOLDER "${TOP_LEVEL}/magic")
file(GLOB MAGIC_FILES
    "${MAGIC_FOLDER}/*"
)

add_executable(magic_test
        source/main.cpp
)

find_package(PkgConfig REQUIRED)
pkg_search_module(MAGIC libmagic>=5.39)

target_include_directories(magic_test PRIVATE include)
target_link_libraries(magic_test PRIVATE libpl magic fmt::fmt-header-only)

set_target_properties(magic_test PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

foreach (magic_file IN LISTS MAGIC_FILES)
    file(RELATIVE_PATH MAGIC_NAME ${MAGIC_FOLDER} ${magic_file})

    set(TEST_NAME "Magic/${MAGIC_NAME}")

    add_test(NAME ${TEST_NAME} COMMAND magic_test "${MAGIC_NAME}" "${magic_file}" WORKING_DIRECTORY ${CMAKE_BINARY_DIR})
    set_tests_properties(${TEST_NAME} PROPERTIES SKIP_RETURN_CODE 77)
endforeach ()

=== tests/patterns/CMakeLists.txt ===
--- 
+++ 
@@ -22,16 +22,22 @@
 foreach (pattern IN LISTS PATTERNS)
     get_filename_component(PATTERN_NAME ${pattern} NAME)
 
-    file(GLOB TEST_FILES "${CMAKE_CURRENT_SOURCE_DIR}/test_data/${PATTERN_NAME}.*")
+    file(GLOB TEST_FILES "${CMAKE_CURRENT_SOURCE_DIR}/test_data/${PATTERN_NAME}/*")
+    if (NOT TEST_FILES)
+        file(GLOB TEST_FILES "${CMAKE_CURRENT_SOURCE_DIR}/test_data/${PATTERN_NAME}.*")
+        list(SUBLIST TEST_FILES 0 1 TEST_FILES)
+    endif ()
 
     if (TEST_FILES)
-        list(GET TEST_FILES 0 TEST_FILE)
+        foreach (TEST_FILE IN LISTS TEST_FILES)
+            get_filename_component(TEST_FILENAME ${TEST_FILE} NAME)
+            set(TEST_NAME "Patterns/${PATTERN_NAME}/${TEST_FILENAME}")
+            add_test(NAME ${TEST_NAME} COMMAND patterns_tests "${PATTERN_NAME}" "${pattern}" "${PATTERN_INCLUDES}" "${TEST_FILE}" WORKING_DIRECTORY ${CMAKE_BINARY_DIR})
+            set_tests_properties(${TEST_NAME} PROPERTIES SKIP_RETURN_CODE 77)
+        endforeach ()
     else ()
-        set(TEST_FILE "")
+        set(TEST_NAME "Patterns/${PATTERN_NAME}")
+        add_test(NAME ${TEST_NAME} COMMAND patterns_tests "${PATTERN_NAME}" "${pattern}" "${PATTERN_INCLUDES}" WORKING_DIRECTORY ${CMAKE_BINARY_DIR})
+        set_tests_properties(${TEST_NAME} PROPERTIES SKIP_RETURN_CODE 77)
     endif ()
-
-    set(TEST_NAME "Patterns/${PATTERN_NAME}")
-
-    add_test(NAME ${TEST_NAME} COMMAND patterns_tests "${PATTERN_NAME}" "${pattern}" "${PATTERN_INCLUDES}" "${TEST_FILE}" WORKING_DIRECTORY ${CMAKE_BINARY_DIR})
-    set_tests_properties(${TEST_NAME} PROPERTIES SKIP_RETURN_CODE 77)
 endforeach ()

=== debian/changelog ===
imhex-patterns (1.35.4-0kali1) kali-dev; urgency=medium

  * New upstream version 1.35.4

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 22 Aug 2024 17:41:51 +0200

imhex-patterns (1.34.0-0kali1) kali-dev; urgency=medium

  * Fix debian/watch
  * New upstream version 1.34.0
  * Update installation

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 07 Jun 2024 13:17:58 +0200

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,15 @@
 Source: imhex-patterns
 Section: misc
 Priority: optional
-Maintainer: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
-Uploaders: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
+Maintainer: Kali Developers <devel@kali.org>
+Uploaders: Sophie Brun <sophie@offensive-security.com>
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
 Standards-Version: 4.6.2
 Homepage: https://github.com/WerWolv/ImHex-Patterns
+Vcs-Browser: https://gitlab.com/kalilinux/packages/imhex-patterns
+Vcs-Git: https://gitlab.com/kalilinux/packages/imhex-patterns.git
 
 Package: imhex-patterns
 Architecture: all

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
    https://github.com/WerWolv/ImHex-Patterns/tags \
    (?:.*?/)ImHex-v?@ANY_VERSION@@ARCHIVE_EXT@

## imhex-patterns 1.37.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(ImHex-Patterns)

option(IMHEX_PATTERNS_ENABLE_UNIT_TESTS "Enable building unit tests for ImHex-Patterns"          OFF)

# if enabled, add a unit_test custom target for all the unit tests to be registered against
if(IMHEX_PATTERNS_ENABLE_UNIT_TESTS)
    if(NOT TARGET unit_tests)
        enable_testing()
        add_custom_target(unit_tests)
    endif()
endif()

# If this has been manually cloned into another project, libpl may already have been set up
if(NOT TARGET libpl)
    include(FetchContent)

    FetchContent_Declare(
        pattern_language
        GIT_REPOSITORY      https://github.com/WerWolv/PatternLanguage
        GIT_TAG             master
    )

    FetchContent_MakeAvailable(pattern_language)
endif()

if(IMHEX_PATTERNS_ENABLE_UNIT_TESTS)
    add_subdirectory(tests)
endif()

=== tests/includes/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(includes_test)

set(TOP_LEVEL "${CMAKE_CURRENT_SOURCE_DIR}/../..")

file(GLOB INCLUDES
    "${TOP_LEVEL}/includes/*/*.pat"
)

set(PATTERN_INCLUDES "${TOP_LEVEL}/includes")

add_executable(includes_test
        source/main.cpp
)

target_include_directories(includes_test PRIVATE include)
target_link_libraries(includes_test PRIVATE libpl fmt::fmt-header-only)

set_target_properties(includes_test PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

message(STATUS "Adding Include Tests")
foreach (include IN LISTS INCLUDES)
    file(RELATIVE_PATH INCLUDE_NAME ${PATTERN_INCLUDES} ${include})

    set(TEST_NAME "Includes/${INCLUDE_NAME}")

    add_test(NAME ${TEST_NAME} COMMAND includes_test "${INCLUDE_NAME}" "${include}" "${PATTERN_INCLUDES}" WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
    set_tests_properties(${TEST_NAME} PROPERTIES SKIP_RETURN_CODE 77)
endforeach ()
add_dependencies(unit_tests ${PROJECT_NAME})

=== tests/magic/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(magic_test)

set(TOP_LEVEL "${CMAKE_CURRENT_SOURCE_DIR}/../..")

set(MAGIC_FOLDER "${TOP_LEVEL}/magic")
file(GLOB MAGIC_FILES
    "${MAGIC_FOLDER}/*"
)

add_executable(magic_test
        source/main.cpp
)

find_package(PkgConfig REQUIRED)
pkg_search_module(MAGIC libmagic>=5.39 REQUIRED)

target_include_directories(magic_test PRIVATE include ${MAGIC_INCLUDE_DIRS})
target_link_libraries(magic_test PRIVATE libpl ${MAGIC_LINK_LIBRARIES} fmt::fmt-header-only)

set_target_properties(magic_test PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

message(STATUS "Adding Magic Tests")
foreach (magic_file IN LISTS MAGIC_FILES)
    file(RELATIVE_PATH MAGIC_NAME ${MAGIC_FOLDER} ${magic_file})

    set(TEST_NAME "Magic/${MAGIC_NAME}")

    add_test(NAME ${TEST_NAME} COMMAND magic_test "${MAGIC_NAME}" "${magic_file}" WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
    set_tests_properties(${TEST_NAME} PROPERTIES SKIP_RETURN_CODE 77)
endforeach ()
add_dependencies(unit_tests ${PROJECT_NAME})

=== debian/changelog ===
imhex-patterns (1.37.4-0kali1) kali-dev; urgency=medium

  [ Arnaud Rebillout ]
  * Drop 'Rules-Requires-Root: no' from d/control

  [ Sophie Brun ]
  * Update my email
  * New upstream version 1.37.4 (see 9291)
  * Add missing build-dep cmake

 -- Sophie Brun <sophie@kali.org>  Mon, 15 Sep 2025 16:56:40 +0200

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,10 @@
 Section: misc
 Priority: optional
 Maintainer: Kali Developers <devel@kali.org>
-Uploaders: Sophie Brun <sophie@offensive-security.com>
-Rules-Requires-Root: no
+Uploaders: Sophie Brun <sophie@kali.org>
 Build-Depends:
  debhelper-compat (= 13),
+ cmake
 Standards-Version: 4.6.2
 Homepage: https://github.com/WerWolv/ImHex-Patterns
 Vcs-Browser: https://gitlab.com/kalilinux/packages/imhex-patterns

## imhex-patterns 1.38.0

=== debian/changelog ===
imhex-patterns (1.38.0-0kali1) kali-dev; urgency=medium

  * New upstream version 1.38.0

 -- Sophie Brun <sophie@kali.org>  Tue, 16 Dec 2025 15:19:50 +0100

## imhex-patterns 1.38.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -16,10 +16,22 @@
 if(NOT TARGET libpl)
     include(FetchContent)
 
+    if (NOT DEFINED IMHEX_PATTERNS_LIBPL_GIT_REPO OR IMHEX_PATTERNS_LIBPL_GIT_REPO STREQUAL "")
+        set(LIBPL_GIT_REPO "https://github.com/WerWolv/PatternLanguage")
+    else()
+        set(LIBPL_GIT_REPO ${IMHEX_PATTERNS_LIBPL_GIT_REPO})
+    endif()
+
+    if (NOT DEFINED IMHEX_PATTERNS_LIBPL_GIT_HASH OR IMHEX_PATTERNS_LIBPL_GIT_HASH STREQUAL "")
+        set(LIBPL_GIT_TAG "master")
+    else()
+        set(LIBPL_GIT_TAG ${IMHEX_PATTERNS_LIBPL_GIT_HASH})
+    endif()
+
     FetchContent_Declare(
         pattern_language
-        GIT_REPOSITORY      https://github.com/WerWolv/PatternLanguage
-        GIT_TAG             master
+        GIT_REPOSITORY      ${LIBPL_GIT_REPO}
+        GIT_TAG             ${LIBPL_GIT_TAG}
     )
 
     FetchContent_MakeAvailable(pattern_language)

=== debian/changelog ===
imhex-patterns (1.38.1-0kali1) kali-dev; urgency=medium

  * New upstream version 1.38.1

 -- Sophie Brun <sophie@kali.org>  Thu, 08 Jan 2026 16:36:27 +0100
